package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.jdbc.framework.processor.BeanListProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.button.AbstractBtnReg;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.uapde.dialog.MessageDialog;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;

public class GenOtheroutinAction extends AbstractAction{
	OrderTestUI frameUI = null;
	IVOPersistence ivo = NCLocator.getInstance().lookup(IVOPersistence.class);

	public GenOtheroutinAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		if (null != s ){
			OrderMainVO headvo = (OrderMainVO) s.getParentVO();
			String vbillno = headvo.getVbillno();
			CircularlyAccessibleValueObject[] oldchildvos = s.getAllChildrenVO();
			OrderIssueVO[] issueArrays = getIssueVOs(oldchildvos);
			List<OrderIssueVO> execList = new ArrayList<>();
			for(OrderIssueVO issuevo : issueArrays) {
				Object bdef3 = issuevo.getBdef3();//是否委外
				if(bdef3 != null && bdef3.equals("Y") ) {
					execList.add(issuevo);
				}
			}
			delICVos(oldchildvos);
			if(execList.size() != 0) {
				AddICVos(execList);
			}
			getFrameUI().getBtnManager().getCmdByID(AbstractBtnReg.SYSBTN_REFRESH).execute();
		}
	}
	
	//根据aggvo获取issuevo数组
	private OrderIssueVO[] getIssueVOs(CircularlyAccessibleValueObject[] oldchildvos) {
		List<OrderIssueVO> issuevos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : oldchildvos) {
			if(vo instanceof OrderIssueVO) {
				issuevos.add((OrderIssueVO)vo);
			}
		}
		Object[] objArrays = issuevos.toArray();
		OrderIssueVO[] issueArrays = new OrderIssueVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			issueArrays[i] = (OrderIssueVO) objArrays[i];
		}
		return issueArrays;
	}
	
	//删除已存在的出库页签
	private void delICVos(CircularlyAccessibleValueObject[] oldchildvos) {
		try {
			for(CircularlyAccessibleValueObject vo : oldchildvos) {
				if(vo instanceof OrderOtheroutVO) {
					ivo.deleteVO((OrderOtheroutVO)vo);
				}
				if(vo instanceof OrderOtherinVO) {
					ivo.deleteVO((OrderOtherinVO)vo);
				}
			}
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			MessageDialog.showErrorDlg(e);
			return;
		}
	}
	
	//材料出库单勾选是否委外生成出库页签
	private void AddICVos(List<OrderIssueVO> execList) {
		try {
			for(OrderIssueVO issuevo : execList) {
				OrderOtheroutVO outvo = new OrderOtheroutVO();
				outvo.setPk_order(issuevo.getPk_order());
				outvo.setPrjtypecode(issuevo.getPrjtypecode());
				outvo.setStandard(issuevo.getStandard());
				outvo.setNum(issuevo.getNum());
				outvo.setCmaterialname(issuevo.getCmaterialname());
				outvo.setConf(issuevo.getConf());
				outvo.setExecnum(issuevo.getExecnum());
				outvo.setDr(issuevo.getDr());
				outvo.setSpec(issuevo.getSpec());
				outvo.setNprice(issuevo.getNprice());
				outvo.setTaxprice(issuevo.getTaxprice());
				outvo.setModel(issuevo.getModel());
				outvo.setHeight(issuevo.getHeight());
				outvo.setTax(issuevo.getTax());
				outvo.setCastunitid(issuevo.getCastunitid());
				outvo.setWeight(issuevo.getWeight());
				outvo.setPrjtypename(issuevo.getPrjtypename());
				outvo.setExecnastnum(issuevo.getExecnastnum());
				outvo.setSizing(issuevo.getSizing());
				outvo.setAlloy(issuevo.getAlloy());
				outvo.setColor(issuevo.getColor());
				outvo.setNastnum(issuevo.getNastnum());
				outvo.setPrjcode(issuevo.getPrjcode());
				outvo.setTaxmny(issuevo.getTaxmny());
				outvo.setCmaterialcode(issuevo.getCmaterialcode());
				outvo.setRound(issuevo.getRound());
				outvo.setPrjname(issuevo.getPrjname());
				outvo.setVbatchcode(issuevo.getVbatchcode());
				outvo.setWidth(issuevo.getWidth());
				outvo.setNmny(issuevo.getNmny());
				outvo.setUnitid(issuevo.getUnitid());
				outvo.setTs(PubEnv.getServerTime());
				outvo.setBdef1(issuevo.getPk_order_issue());
				ivo.insertVO(outvo);
//				outvo.setBdef2(null);
//				outvo.setBdef3(issuevo.getBdef3());
//				outvo.setBdef4(issuevo.getBdef4());
//				outvo.setBdef5(issuevo.getBdef5());
//				outvo.setBdef6(issuevo.getBdef6());
//				outvo.setBdef7(issuevo.getBdef7());
//				outvo.setBdef8(issuevo.getBdef8());
//				outvo.setBdef9(issuevo.getBdef9());
//				outvo.setBdef10(issuevo.getBdef10());
//				outvo.setBdef11(issuevo.getBdef11());
//				outvo.setBdef12(issuevo.getBdef12());
//				outvo.setBdef13(issuevo.getBdef13());
//				outvo.setBdef14(issuevo.getBdef14());
//				outvo.setBdef15(issuevo.getBdef15());
//				outvo.setBdef16(issuevo.getBdef16());
//				outvo.setBdef17(issuevo.getBdef17());
//				outvo.setBdef18(issuevo.getBdef18());
//				outvo.setBdef19(issuevo.getBdef19());
//				outvo.setBdef20(issuevo.getBdef20());
				OrderOtherinVO invo = new OrderOtherinVO();
				invo.setPk_order(issuevo.getPk_order());
				invo.setPrjtypecode(issuevo.getPrjtypecode());
				invo.setStandard(issuevo.getStandard());
				invo.setNum(issuevo.getNum());
				invo.setCmaterialname(issuevo.getCmaterialname());
				invo.setConf(issuevo.getConf());
				invo.setExecnum(issuevo.getExecnum());
				invo.setDr(issuevo.getDr());
				invo.setSpec(issuevo.getSpec());
				invo.setNprice(issuevo.getNprice());
				invo.setTaxprice(issuevo.getTaxprice());
				invo.setModel(issuevo.getModel());
				invo.setHeight(issuevo.getHeight());
				invo.setTax(issuevo.getTax());
				invo.setCastunitid(issuevo.getCastunitid());
				invo.setWeight(issuevo.getWeight());
				invo.setPrjtypename(issuevo.getPrjtypename());
				invo.setExecnastnum(issuevo.getExecnastnum());
				invo.setSizing(issuevo.getSizing());
				invo.setAlloy(issuevo.getAlloy());
				invo.setColor(issuevo.getColor());
				invo.setNastnum(issuevo.getNastnum());
				invo.setPrjcode(issuevo.getPrjcode());
				invo.setTaxmny(issuevo.getTaxmny());
				invo.setCmaterialcode(issuevo.getCmaterialcode());
				invo.setRound(issuevo.getRound());
				invo.setPrjname(issuevo.getPrjname());
				invo.setVbatchcode(issuevo.getVbatchcode());
				invo.setWidth(issuevo.getWidth());
				invo.setNmny(issuevo.getNmny());
				invo.setUnitid(issuevo.getUnitid());
				invo.setTs(PubEnv.getServerTime());
				invo.setBdef1(issuevo.getPk_order_issue());
				ivo.insertVO(invo);
//				invo.setBdef2(null);
//				invo.setBdef3(issuevo.getBdef3());
//				invo.setBdef4(issuevo.getBdef4());
//				invo.setBdef5(issuevo.getBdef5());
//				invo.setBdef6(issuevo.getBdef6());
//				invo.setBdef7(issuevo.getBdef7());
//				invo.setBdef8(issuevo.getBdef8());
//				invo.setBdef9(issuevo.getBdef9());
//				invo.setBdef10(issuevo.getBdef10());
//				invo.setBdef11(issuevo.getBdef11());
//				invo.setBdef12(issuevo.getBdef12());
//				invo.setBdef13(issuevo.getBdef13());
//				invo.setBdef14(issuevo.getBdef14());
//				invo.setBdef15(issuevo.getBdef15());
//				invo.setBdef16(issuevo.getBdef16());
//				invo.setBdef17(issuevo.getBdef17());
//				invo.setBdef18(issuevo.getBdef18());
//				invo.setBdef19(issuevo.getBdef19());
//				invo.setBdef20(issuevo.getBdef20());
			}
		} catch (BusinessException e) {
			// TODO Auto-generated catch block
			MessageDialog.showErrorDlg(e);
			return;
		}
	}

}
