package u8c.ui.mmpac.action;

import java.util.ArrayList;
import java.util.List;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IVOPersistence;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.pubitf.ic.out.IOtherOutMaintainAPI;
import u8c.ui.mmpac.panel.OrderMainPanel;
import u8c.ui.mmpac.panel.OrderTestUI;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;
import u8c.vo.OrderOtherinVO;
import u8c.vo.OrderOtheroutVO;

public class PushOtherOutAction extends AbstractAction{
	OrderTestUI frameUI = null;
	IOtherOutMaintainAPI iotherout = NCLocator.getInstance().lookup(IOtherOutMaintainAPI.class);

	public PushOtherOutAction(FrameUI frameUI1) {
		super(frameUI1);
		this.frameUI = (OrderTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OrderMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();
		if (null != s && s != null){
			OrderMainVO headvo = (OrderMainVO) s.getParentVO();
			int billstatus = headvo.getBillstatus();
			if(billstatus != 1) {
				throw new ValidationException("非审批态单据不允许生成其他出库单");
			}
			String pk_corp = headvo.getPk_corp();
			String pk_order = headvo.getPk_order();
			OrderOtheroutVO[] outvos = getOutVOs(s);
			if(outvos.length != 0) {
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(PubEnv.getServerDate());
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				icheadvo.setCwarehouseid("1001V5100000000003A1");//仓库必填
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setBassetcard(UFBoolean.FALSE);
				icheadvo.setCbilltypecode("4I");
				icheadvo.setFbillflag(2);
				icheadvo.setFreplenishflag(UFBoolean.FALSE);
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[outvos.length];
				for(int i = 0;i < outvos.length;i++) {
					OrderOtheroutVO outvo = outvos[i];
					GeneralBillItemVO itemvo = new GeneralBillItemVO();
					String cmaterialcode = outvo.getCmaterialcode();
					String pk_invbasdoc = "";//存货pk
					if(cmaterialcode.startsWith("0001")) {
						pk_invbasdoc = cmaterialcode;
					}
					else {
						InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
						pk_invbasdoc = invbasvo.getPrimaryKey();
					}
					String prjcode = outvo.getPrjcode();
					String cprojectid = "";
					if(prjcode.startsWith("1001")) {
						cprojectid = prjcode;
					}
					else {
						cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
					}
					InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
					String pk_invmandoc = invmanvo.getPrimaryKey();
					itemvo.setBbarcodeclose(UFBoolean.FALSE);
					itemvo.setAttributeValue("bonroadflag", "N");
					itemvo.setBreturnprofit(UFBoolean.FALSE);
					itemvo.setBsafeprice(UFBoolean.FALSE);
					itemvo.setBsourcelargess(UFBoolean.FALSE);
					itemvo.setAttributeValue("btoinzgflag", "N");
					itemvo.setAttributeValue("btoouttoiaflag", "N");
					itemvo.setBtou8rm(UFBoolean.FALSE);
					itemvo.setBtransasset(UFBoolean.FALSE);
					itemvo.setBzgflag(UFBoolean.FALSE);
					itemvo.setCbodybilltypecode("4I");
					itemvo.setCbodywarehouseid("1001V5100000000003A1");
					itemvo.setCfirstbillhid(pk_order);
					itemvo.setCfirstbillbid(outvo.getPrimaryKey());
					itemvo.setCfirsttype("55A2");
					itemvo.setCinvbasid(pk_invbasdoc);
					itemvo.setCinventoryid(pk_invmandoc);
					icheadvo.setCinventoryid(pk_invmandoc);
					itemvo.setCrowno(Integer.toString((i+1)*10));
					itemvo.setCsourcebillhid(pk_order);
					itemvo.setCsourcebillbid(outvo.getPrimaryKey());
					itemvo.setCsourcetype("55A2");
					itemvo.setDbizdate(PubEnv.getServerDate());
					itemvo.setFassertcardflag(UFBoolean.FALSE);
					itemvo.setFchecked(0);
					itemvo.setFlargess(UFBoolean.FALSE);
					itemvo.setIsok(UFBoolean.FALSE);
					itemvo.setNbarcodenum(new UFDouble(0));
					itemvo.setNoutnum(outvo.getNum());
					itemvo.setNplannedprice(outvo.getNprice());
					itemvo.setNplannedmny(outvo.getNmny());
					itemvo.setNprice(outvo.getNprice());
					itemvo.setNmny(outvo.getNmny());
					itemvo.setNshouldoutnum(outvo.getNum());
					itemvo.setPk_calbody(icheadvo.getPk_calbody());
					itemvo.setVbatchcode(outvo.getVbatchcode()==null?"":outvo.getVbatchcode());
					itemvo.setVfirstbillcode(headvo.getVbillno());
					itemvo.setVfree1(outvo.getColor());
					itemvo.setVfree2(outvo.getSizing());
					itemvo.setVfree3(outvo.getAlloy());
					itemvo.setVfree4(outvo.getStandard());
					itemvo.setVsourcebillcode(headvo.getVbillno());
					itemvos[i] = itemvo;
				}
				aggvo.setChildrenVO(itemvos);
				aggvos[0] = aggvo;
				GeneralBillVO[] res = iotherout.insertOtherOuts(aggvos);
				GeneralBillVO resvo = res[0];
				MessageDialog.showHintDlg(frameUI, "成功", "其他出库单"+resvo.getVBillCode()+"新增成功");
			}
			else {
				MessageDialog.showHintDlg(frameUI, "提示", "该生产订单没有其他出库数据，不能生成其他出库单");
				return;
			}
		}
	}
	

	//获取其他出库数据
	private OrderOtheroutVO[] getOutVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OrderOtheroutVO> outvos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderOtheroutVO) {
				outvos.add((OrderOtheroutVO)vo);
			}
		}
		Object[] objArrays = outvos.toArray();
		OrderOtheroutVO[] outArrays = new OrderOtheroutVO[objArrays.length];
		for(int i = 0;i < objArrays.length;i++) {
			outArrays[i] = (OrderOtheroutVO) objArrays[i];
		}
		return outArrays;
	}

}
