package u8c.ui.mmpac.action;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JSplitPane;
import nc.bs.dao.BaseDAO;
import nc.ui.pub.beans.UIPanel;
import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.in.IProductInMaintainAPI;
import u8c.vo.OrderInVO;
import u8c.vo.OrderMainVO;


@SuppressWarnings("deprecation")
public class TOProductOutDialog extends UIDialog implements ActionListener,BillEditListener{
	/**
	 * 弹框勾选推单生成下游单据-产成品入库
	 */
	private static final long serialVersionUID = -2605551888165671265L;
	private UISplitPane mainpanel = null;//主面板
	private BillCardPanel jlcardPanel = null;//卡面面板
	private UIPanel jlbtnpanel = null;//存放按钮的panel
	private UIButton saveCardBtn = null ; //保存
	private UIButton cancelBtn = null ; //取消
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private OrderMainVO headvo;
	
	private IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
//	public GxCLCDialog() {
//		super();
//		initialize();
//		
//	}
	
	public TOProductOutDialog(OrderInVO[] orderInVOs,OrderMainVO headvo) {
		super();
		this.headvo = headvo;
		initialize(orderInVOs);
		
	}
	
	
	public void initialize(OrderInVO[] orderInVOs){
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("clc");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("生产总订单-入库");
		setSize(1000,360);
		this.setResizable(true);
		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
		setContentPane(getMainPanel());
		addListenerEvent();
		//展示数据
		getJlcardPanel().getBillModel().setBodyDataVO(orderInVOs);
		
		
	}
	
	
	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
	}
	
	public UISplitPane getMainPanel(){
		if(mainpanel==null){
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(280);//分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		
		return mainpanel;
	}
	
	
	public UIPanel getJlbtnpanel() {
		if(jlbtnpanel==null){
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}
	
	public UIButton getSaveCardBtn() {
		
		if(saveCardBtn == null){
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530,210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}
	
	public UIButton getCancelBtn() {
		if(cancelBtn == null){
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530,210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}
	
	
	private BillCardPanel getJlcardPanel() {
		if(jlcardPanel==null){
			jlcardPanel=new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			jlcardPanel.loadTemplet("QS412",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
		}
		
		return jlcardPanel;
	}
	
	
	@Override
	public void afterEdit(BillEditEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void bodyRowChange(BillEditEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	@SuppressWarnings("unchecked")
	@Override
	/**
	 * 按钮确定和取消执行方法
	 */
	public void actionPerformed(ActionEvent e) {
		try {
			//保存按钮
			if(e.getSource() == getSaveCardBtn()){
				Vector<Vector<Object>> vectors = getJlcardPanel().getBillModel().getDataVector();
				StringBuffer errmsg = new StringBuffer();
				//数量校验
				for(int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(i);
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						if(vector.get(1) == null) {
							errmsg.append("第"+(i+1)+"行本次执行数量为空！");
							continue;
						}
						UFDouble execnum = new UFDouble(vector.get(1).toString());//本次执行数量
						UFDouble nnum = new UFDouble(vector.get(21).toString());//主数量
						UFDouble usednum = vector.get(29) == null?new UFDouble(0):new UFDouble(vector.get(29).toString());//已执行主数量
						if(execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第"+(i+1)+"行本次执行数量超过订单剩余数量！");
						}
					}
				}
				if(!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				
				String pk_corp = headvo.getPk_corp();
				UFDate dbilldate = headvo.getDbilldate();
				String pk_order = headvo.getPk_order();
				String workmanid = headvo.getWorkmanid();
				String plandeptid = headvo.getPlandeptid();
				String Pk_calbody = GetBaseDAOUtil.getcalpk(pk_corp);
				GeneralBillVO aggvo = new GeneralBillVO();
				List<GeneralBillItemVO> listGeneralBillItemVO = new ArrayList<GeneralBillItemVO>();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				//公司ID
				icheadvo.setPk_corp(pk_corp);
				//库存组织PK 
				icheadvo.setPk_calbody(Pk_calbody);
				//库存单据类型
				icheadvo.setCbilltypecode("46");//默认库存产成品入库单
				//单据日期
				icheadvo.setDbilldate(dbilldate);
				//制单人
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				//仓库ID
				icheadvo.setCwarehouseid("1001V5100000000003GB");//仓库必填
				//业务员
				icheadvo.setCbizid(workmanid);
				//部门
				icheadvo.setCdptid(plandeptid);
				//备注
				icheadvo.setVnote(headvo.getVnote());
				//操作员
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());
				aggvo.setParentVO(icheadvo);
				Map<String, UFDouble> updatemap = new HashMap<>();
				for(int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(j);
					//自定义项20 为勾选按钮 ：勾选为Y 没有勾选是null
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						GeneralBillItemVO itemvo = new GeneralBillItemVO();
						String cmaterialcode = vector.get(7).toString();
						String pk_invbasdoc = "";//存货pk
						if(cmaterialcode.startsWith("0001")) {
							pk_invbasdoc = cmaterialcode;
						}
						else {
							InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
							pk_invbasdoc = invbasvo.getPrimaryKey();
						}
							String prjcode = vector.get(2).toString();
							String cprojectid = "";
						if(prjcode.startsWith("1001")) {
							cprojectid = prjcode;
						}
						else {
							cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
						}
							
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
						String pk_invmandoc = invmanvo.getPrimaryKey();
						
						
						//单据行是否条码关闭
						itemvo.setBbarcodeclose(UFBoolean.FALSE);
						//是否返利
						itemvo.setBreturnprofit(UFBoolean.FALSE);
						//是否价保
						itemvo.setBsafeprice(UFBoolean.FALSE);
						//上游是否赠品行
						itemvo.setBsourcelargess(UFBoolean.FALSE);
						//是否已下发零售
						itemvo.setBtou8rm(UFBoolean.FALSE);
						itemvo.setBtransasset(UFBoolean.FALSE);
						//暂估标志
						itemvo.setBzgflag(UFBoolean.FALSE);
						//单据类型
						itemvo.setCbodybilltypecode("46");
						//库存仓库
						itemvo.setCbodywarehouseid("1001V5100000000003GB");
						//存货基本ID
						itemvo.setCinvbasid(pk_invbasdoc);
						//存货ID
						itemvo.setCinventoryid(pk_invmandoc);
						//行号
						itemvo.setCrowno("10");
						//业务日期
						itemvo.setDbizdate(dbilldate);
						//是否生成设备卡片
						itemvo.setFassertcardflag(UFBoolean.FALSE);
						//待检标志
						itemvo.setFchecked(0);
						//是否赠品
						itemvo.setFlargess(UFBoolean.FALSE);
						//结算完毕标志
						itemvo.setIsok(UFBoolean.FALSE);
						//条码数量
						itemvo.setNbarcodenum(new UFDouble(0));
						//实入数量
						itemvo.setNinnum(vector.get(1) == null ? null : new UFDouble(vector.get(1).toString()));
						//应入数量
						itemvo.setNshouldinnum(vector.get(1) == null ? null : new UFDouble(vector.get(1).toString()));
						//金额
						itemvo.setNmny(vector.get(24)== null ? null : new UFDouble(vector.get(24).toString()));
						//单价
						itemvo.setNprice(vector.get(26) == null ? null : new UFDouble(vector.get(26).toString()));
						//库存组织
						itemvo.setPk_bodycalbody(Pk_calbody);
						//源头单据表头ID
						itemvo.setCfirstbillhid(pk_order);
						//源头单据表体ID 
						itemvo.setCfirstbillbid(vector.get(33).toString());
						//源头单据类型
						itemvo.setCfirsttype("55A2");					
						//项目ID
						itemvo.setCprojectid(cprojectid);
						//来源单据表头序列号
						itemvo.setCsourcebillhid(pk_order);
						//来源单据表体序列号
						itemvo.setCsourcebillbid(vector.get(33).toString());
						//来源单据类型
						itemvo.setCsourcetype("55A2");
						//原币无税金额
						itemvo.setNquotentmny(vector.get(24) == null ? null: new UFDouble(vector.get(24).toString()));
						//原币无税单价
						itemvo.setNquotentprice(vector.get(26) == null ? null : new UFDouble(vector.get(26).toString()));
						//不含税金额
						itemvo.setNsalemny(vector.get(24) == null ? null: new UFDouble(vector.get(24).toString()));
						//销售价格
						itemvo.setNsaleprice(vector.get(24) == null ? null: new UFDouble(vector.get(24).toString()));
						//含税金额
						itemvo.setNtaxmny(vector.get(23) == null ? null : new UFDouble(vector.get(23).toString()));
						//含税单价
						itemvo.setNtaxprice(vector.get(22) == null ? null : new UFDouble(vector.get(22).toString()));
						//itemvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
						//批次号
						itemvo.setVbatchcode(vector.get(6) == null ? null : vector.get(6).toString());
						//源头单据号
						itemvo.setVfirstbillcode(headvo.getVbillno());
						//来源单据号
						itemvo.setVsourcebillcode(headvo.getVbillno());
						itemvo.setStatus(2);
						listGeneralBillItemVO.add(itemvo);
						itemvo.setVfree1(vector.get(11) == null ? null : vector.get(11).toString());
						itemvo.setVfree2(vector.get(12) == null ? null : vector.get(12).toString());
						itemvo.setVfree3(vector.get(13) == null ? null : vector.get(13).toString());
						itemvo.setVfree4(vector.get(14) == null ? null : vector.get(14).toString());
						UFDouble updatenum =  new UFDouble(vector.get(29)==null?"0":vector.get(29).toString()).add(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						updatemap.put(vector.get(33).toString(), updatenum);
					}
				}
				aggvo.setChildrenVO(listGeneralBillItemVO.toArray(new GeneralBillItemVO[listGeneralBillItemVO.size()]));		
				iorder.insertProduct(new GeneralBillVO[]{aggvo},updatemap);
				this.closeCancel();
			}
			//取消按钮
			if(e.getSource() == getCancelBtn()){
				this.closeCancel();
			}
		} catch (Exception e1) {
			MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
		}
		
	}

}







