package u8c.ui.mmpac.action;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Vector;

import javax.swing.JSplitPane;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.pf.IPFBusiAction;
import nc.itf.uap.pf.IplatFormEntry;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.ui.pub.beans.UIButton;
import nc.ui.pub.beans.UIDialog;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UISplitPane;
import nc.ui.pub.bill.BillCardPanel;
import nc.ui.pub.bill.BillEditEvent;
import nc.ui.pub.bill.BillEditListener;
import nc.vo.bd.invdoc.InvbasdocVO;
import nc.vo.bd.invdoc.InvmandocVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.ic.pub.bill.GeneralBillHeaderVO;
import nc.vo.ic.pub.bill.GeneralBillItemVO;
import nc.vo.ic.pub.bill.GeneralBillVO;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.pub.pf.PfUtilWorkFlowVO;
import nc.vo.pub.workflownote.WorkflownoteVO;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.itf.mmpac.mmpac.IOrderTotalInfo;
import u8c.pubitf.ic.out.ISaleOutMaintainAPI;
import u8c.vo.OrderInVO;
import u8c.vo.OrderIssueVO;
import u8c.vo.OrderMainVO;

@SuppressWarnings("deprecation")
public class ToSaleOutDialog extends UIDialog implements ActionListener,BillEditListener{

	private static final long serialVersionUID = -2605551888165671266L;
	private UISplitPane mainpanel = null;//主面板
	private BillCardPanel jlcardPanel = null;//卡面面板
	private UIPanel jlbtnpanel = null;//存放按钮的panel
	private UIButton saveCardBtn = null ; //保存
	private UIButton cancelBtn = null ; //取消
	private ClientEnvironment ce = ClientEnvironment.getInstance();
	private HRAggVO aggvo;
	ISaleOutMaintainAPI isaleout = NCLocator.getInstance().lookup(ISaleOutMaintainAPI.class);
	IOrderTotalInfo iorder = NCLocator.getInstance().lookup(IOrderTotalInfo.class);
	IplatFormEntry iIplatFormEntry = NCLocator.getInstance().lookup(IplatFormEntry.class);
	

	public ToSaleOutDialog(HRAggVO aggvo) {
		super();
		initialize(aggvo);
	}

	private void initialize(HRAggVO aggvo) {
		Dimension dimension = Toolkit.getDefaultToolkit().getScreenSize();
		setName("saleoutdlg");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		setTitle("生产总订单入库-销售出库");
		setSize(1000,360);
		this.setResizable(true);
		setLocation((dimension.width-550)/2, (dimension.height-300)/2);
		setContentPane(getMainPanel());
		addListenerEvent();
		this.aggvo = aggvo;
		//展示数据
		OrderInVO[] inArrays = getInVOs(aggvo);
		getJlcardPanel().getBillModel().setBodyDataVO(inArrays);
	}

	//按钮监听
	private void addListenerEvent() {
		getSaveCardBtn().addActionListener(this);
		getCancelBtn().addActionListener(this);
		getJlcardPanel().addEditListener(this);
	}

	private UISplitPane getMainPanel() {
		if(mainpanel==null){
			mainpanel = new UISplitPane();
			mainpanel.setOrientation(JSplitPane.VERTICAL_SPLIT);
			mainpanel.setTopComponent(getJlcardPanel());
			mainpanel.setBottomComponent(getJlbtnpanel());
			mainpanel.setDividerLocation(280);//分割位置
			mainpanel.setOneTouchExpandable(true);
			mainpanel.setDividerSize(8);
		}
		
		return mainpanel;
	}

	private UIPanel getJlbtnpanel() {
		if(jlbtnpanel==null){
			jlbtnpanel = new UIPanel();
			jlbtnpanel.setName("jlbtnpanel");
			jlbtnpanel.add(getSaveCardBtn());
			jlbtnpanel.add(getCancelBtn());
		}
		return jlbtnpanel;
	}

	private UIButton getCancelBtn() {
		if(cancelBtn == null){
			cancelBtn = new UIButton();
			cancelBtn.setBounds(530,210, 75, 20);
			cancelBtn.setName("cancelBtn");
			cancelBtn.setText("取消");
		}
		return cancelBtn;
	}

	private UIButton getSaveCardBtn() {
		if(saveCardBtn == null){
			saveCardBtn = new UIButton();
			saveCardBtn.setBounds(530,210, 20, 20);
			saveCardBtn.setName("saveCardBtn");
			saveCardBtn.setText("确定");
		}
		return saveCardBtn;
	}

	private BillCardPanel getJlcardPanel() {
		if(jlcardPanel==null){
			jlcardPanel=new BillCardPanel();
			jlcardPanel.setName("jlcardPanel");
			//根据单据模板编码加载模板
			jlcardPanel.loadTemplet("A224C",null,ce.getUser().getPrimaryKey(),ce.getCorporation().getPrimaryKey());
		}
		
		return jlcardPanel;
	}
	
	//根据传入的aggvo获取invo数组
	private OrderInVO[] getInVOs(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OrderInVO> invos = new ArrayList();
		for(CircularlyAccessibleValueObject vo : vos) {
			if(vo instanceof OrderInVO) {
				//本次执行数量不填就默认
				//执行完的表体在生单界面不展示
				OrderInVO invo = (OrderInVO) vo;
				UFDouble num = invo.getNum() == null ? new UFDouble(0) : invo.getNum();
				UFDouble execnum = invo.getExecnum() == null ? new UFDouble(0) : invo.getExecnum();
				if(num.equals(execnum) && num.equals(new UFDouble(0))) {
					continue;
				}
				invo.setBdef2(num.sub(execnum).toString());
				invos.add(invo);
			}
		}
		OrderInVO[] inArrays = new OrderInVO[invos.size()];
		for(int i = 0;i < invos.size();i++) {
			inArrays[i] = invos.get(i);
		}
		return inArrays;
	}

	@Override
	public void afterEdit(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void bodyRowChange(BillEditEvent var1) {
		// TODO Auto-generated method stub
		
	}

	@Override
	public void actionPerformed(ActionEvent e) {

		//保存按钮
		if(e.getSource() == getSaveCardBtn()){
			Vector<Vector<Object>> vectors= getJlcardPanel().getBillModel().getDataVector();
			StringBuffer errmsg = new StringBuffer();
			//数量校验
			try {
				int execsize = 0;//勾选的条数
				for(int i = 0; i < vectors.size(); i++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(i);
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						if(vector.get(1) == null) {
							errmsg.append("第"+(i+1)+"行本次执行数量为空！");
							continue;
						}
						execsize = execsize + 1;
						UFDouble execnum = new UFDouble(vector.get(1).toString());//本次执行数量
						UFDouble nnum = new UFDouble(vector.get(22).toString());//主数量
						UFDouble usednum = vector.get(30) == null?new UFDouble(0):new UFDouble(vector.get(30).toString());//已执行主数量
						if(execnum.compareTo(nnum.sub(usednum)) > 0) {
							errmsg.append("第"+(i+1)+"行本次执行数量超过订单剩余数量！");
						}
					}
				}
				
				if(!errmsg.toString().equals("")) {
					MessageDialog.showErrorDlg(mainpanel, "错误", errmsg.toString());
					return;
				}
				if(execsize == 0) {
					MessageDialog.showHintDlg(mainpanel, "提示", "请勾选要生成销售出库的数据");
					return;
				}
				OrderMainVO headvo = (OrderMainVO) this.aggvo.getParentVO();
				String pk_corp = headvo.getPk_corp();
				String pk_order = headvo.getPk_order();
				GeneralBillVO[] aggvos = new GeneralBillVO[1];
				GeneralBillVO aggvo = new GeneralBillVO();
				GeneralBillHeaderVO icheadvo = new GeneralBillHeaderVO();
				icheadvo.setPk_corp(pk_corp);
				icheadvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
				icheadvo.setDbilldate(PubEnv.getServerDate());
				icheadvo.setCoperatorid(PubEnv.getPk_user());
				icheadvo.setCwarehouseid("1001V5100000000003A1");//仓库必填
				icheadvo.setBoutretflag(UFBoolean.FALSE);//是否退回 
				icheadvo.setBsalecooppur(UFBoolean.FALSE); // 销售出是否已协同生成采购入 
				icheadvo.setVnote("来源生产总订单");//备注
				icheadvo.setCbilltypecode("4C");
				icheadvo.setBassetcard(UFBoolean.FALSE);
				icheadvo.setCbiztypeid("1001V51000000000002V");//业务流程
				icheadvo.setCcustomerid("0001V510000000000AJH");//客户
				icheadvo.setCdptid(headvo.getPlandeptid());//部门
				icheadvo.setFreplenishflag(UFBoolean.FALSE);
				icheadvo.setPk_cubasdocC("0001V510000000000674");//客户基本档案
				icheadvo.setFbillflag(2);
				icheadvo.setCoperatoridnow(PubEnv.getPk_user());//设置当前操作人
				aggvo.setParentVO(icheadvo);
				GeneralBillItemVO[] itemvos = new GeneralBillItemVO[execsize];
				Map<String, UFDouble> updatemap = new HashMap<>();

				int k = 0;
				for(int j = 0; j < vectors.size(); j++) {
					Vector<Object> vector = (Vector<Object>)vectors.get(j);
					//自定义项20为勾选按钮 ：勾选为Y 没有勾选是null
					if(null!=vector.get(0) &&  "Y".equals(vector.get(0).toString())){
						GeneralBillItemVO itemvo = new GeneralBillItemVO();
						String cmaterialcode = vector.get(8).toString();
						String pk_invbasdoc = "";//存货pk
						if(cmaterialcode.startsWith("0001")) {
							pk_invbasdoc = cmaterialcode;
						}
						else {
							InvbasdocVO invbasvo  = GetBaseDAOUtil.getInvVO(cmaterialcode);
							pk_invbasdoc = invbasvo.getPrimaryKey();
						}
						String prjcode = vector.get(3).toString();
						String cprojectid = "";
						if(prjcode.startsWith("1001")) {
							cprojectid = prjcode;
						}
						else {
							cprojectid = GetBaseDAOUtil.getprojectid(prjcode);
						}
						InvmandocVO invmanvo = GetBaseDAOUtil.getInvmanVO(pk_invbasdoc);
						String pk_invmandoc = invmanvo.getPrimaryKey();
						itemvo.setBbarcodeclose(UFBoolean.FALSE);
						itemvo.setBreturnprofit(UFBoolean.FALSE);
						itemvo.setBsafeprice(UFBoolean.FALSE);
						itemvo.setBsourcelargess(UFBoolean.FALSE);
						itemvo.setBtou8rm(UFBoolean.FALSE);
						itemvo.setBtransasset(UFBoolean.FALSE);
						itemvo.setBzgflag(UFBoolean.FALSE);
						itemvo.setCbodybilltypecode("4C");
						itemvo.setCbodywarehouseid("1001V5100000000003A1");
						itemvo.setCfirstbillhid(pk_order);
						itemvo.setCfirstbillbid(vector.get(51).toString());
//						itemvo.setCfirsttype("55A2");
						itemvo.setCinvbasid(pk_invbasdoc);
						itemvo.setCinventoryid(pk_invmandoc);
//						icheadvo.setCinventoryid(pk_invmandoc);
						itemvo.setCinventorycode(cmaterialcode);
						itemvo.setCprojectid(cprojectid);
						itemvo.setCreceieveid("0001V510000000000AJH");//收货单位
						itemvo.setCrowno(Integer.toString((k+1)*10));
						itemvo.setCsourcebillhid(pk_order);
						itemvo.setCsourcebillbid(vector.get(51).toString());
//						itemvo.setCsourcetype("55A2");
						itemvo.setVsourcerowno("10");
						itemvo.setDbizdate(PubEnv.getServerDate());
						itemvo.setDdeliverdate(PubEnv.getServerDate());
						itemvo.setFassertcardflag(UFBoolean.FALSE);
						itemvo.setFchecked(0);
						itemvo.setFlargess(UFBoolean.FALSE);
						itemvo.setIsok(UFBoolean.FALSE);
						itemvo.setNbarcodenum(new UFDouble(0));
						itemvo.setNoutnum(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						itemvo.setNquotentprice(new UFDouble(vector.get(27)==null?"0":vector.get(27).toString()));//原币无税单价
						itemvo.setNquotentmny(itemvo.getNoutnum().multiply(itemvo.getNquotentprice()));//原币无税金额
						itemvo.setAttributeValue("nquoteprice", new UFDouble(vector.get(23)==null?"0":vector.get(23).toString()));//报价含税单价
						itemvo.setAttributeValue("nquotemny", itemvo.getNoutnum().multiply(new UFDouble(vector.get(23)==null?"0":vector.get(23).toString())));//报价含税金额
						itemvo.setNsaleprice(new UFDouble(vector.get(27)==null?"0":vector.get(27).toString()));//销售价格
						itemvo.setNsalemny(itemvo.getNoutnum().multiply(new UFDouble(vector.get(27)==null?"0":vector.get(27).toString())));//销售金额
						itemvo.setNshouldoutnum(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						itemvo.setNtaxprice(new UFDouble(vector.get(23)==null?"0":vector.get(23).toString()));
						itemvo.setNtaxmny(itemvo.getNoutnum().multiply(new UFDouble(vector.get(23)==null?"0":vector.get(23).toString())));
						
						itemvo.setPk_bodycalbody(GetBaseDAOUtil.getcalpk(pk_corp));
						itemvo.setPk_calbody(GetBaseDAOUtil.getcalpk(pk_corp));
						itemvo.setAttributeValue("pk_corp", pk_corp);
						itemvo.setVbatchcode(vector.get(7)==null?"":vector.get(7).toString());
						itemvo.setVfirstbillcode(headvo.getVbillno());
						itemvo.setVfree1(vector.get(12)==null?null:vector.get(12).toString());
						itemvo.setVfree2(vector.get(14)==null?null:vector.get(14).toString());
						itemvo.setVfree3(vector.get(13)==null?null:vector.get(13).toString());
						itemvo.setVfree4(vector.get(15)==null?null:vector.get(15).toString());
						itemvo.setAttributeValue("cquoteunitid", GetBaseDAOUtil.getMeasidByName(vector.get(21).toString()));//报价计量单位
						itemvo.setAttributeValue("cquotecurrency", "00010000000000000001");//报价币种
//						itemvo.setAttributeValue("nquoteunitnum", new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));//报价计量单位数量
//						itemvo.setAttributeValue("nquoteunitrate", 1);//报价计量单位换算率
//						itemvo.setHsl(new UFDouble(1));//换算率
//						itemvo.setCastunitid(GetBaseDAOUtil.getMeasid(vector.get(21).toString()));//辅计量单位
						itemvo.setVsourcebillcode(headvo.getVbillno());
						//回写数量
						UFDouble updatenum =  new UFDouble(vector.get(30)==null?"0":vector.get(30).toString()).add(new UFDouble(vector.get(1)==null?"0":vector.get(1).toString()));
						updatemap.put(vector.get(51).toString(), updatenum);
						itemvos[k]=itemvo;
						k = k + 1;
					}
				}
				aggvo.setChildrenVO(itemvos);
				aggvo.setStatus(VOStatus.NEW);
				aggvos[0] = aggvo;
				GeneralBillVO[] res = isaleout.insertSaleOuts(aggvos);
				GeneralBillVO resvo = res[0];
				Boolean updateres = iorder.UpdateInExecNum(updatemap);
				
				MessageDialog.showHintDlg(mainpanel, "成功", "销售出库单"+resvo.getVBillCode()+"新增成功");
			}  catch (Exception e1) {
				MessageDialog.showErrorDlg(mainpanel, "错误", e1.getMessage());
				return;
			}
		}
		
		//取消按钮
		if(e.getSource() == getCancelBtn()){
			this.closeCancel();
		}
		
	
	}

}
