package u8c.impl;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.UserTransaction;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.microsoft.sqlserver.jdbc.StringUtils;

import nc.bs.dao.BaseDAO;
import nc.bs.framework.adaptor.IHttpServletAdaptor;
import nc.bs.framework.common.NCLocator;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.vo.pub.lang.UFDate;
import nc.vo.trade.pub.IBillStatus;
import u8c.bs.servlet.service.BaseServlet;
import u8c.bs.servlet.service.GetBaseDAOUtil;
import u8c.log.NcLog;
import u8c.vo.DemandBVO;
import u8c.vo.DemandVO;

public class DemandAddImpl extends BaseServlet implements IHttpServletAdaptor{
	private  IUAPQueryBS iuap = NCLocator.getInstance().lookup(IUAPQueryBS.class);
	BaseDAO dao = new BaseDAO();
	UserTransaction trans;

	@Override
	public void doAction(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		try {
			//ӿڷؽ
			JSONObject returnobj = new JSONObject();
			//json
			JSONArray result = new JSONArray();
			//json
			JSONArray errMessage = new JSONArray();
			String token =req.getParameter("token");
			if(!(token!=null && !token.equals("")&&("07a81a68-c60c-4ee4-83dc-25aa51a51497").equals(token))){
				errMessage.add(formatRSJsonData("ʧ","ȷͨѶǷȷ",""));
				returnobj.put("info", "ʧ");
				returnobj.put("errMessage", "ȷͨѶǷȷ");
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			trans = NCLocator.getInstance().lookup(UserTransaction.class);
			trans.begin(); //
			String createStr = buildJson(req, resp, this.getClass().getName());
			JSONObject json = JSON.parseObject(createStr);
			String checkresult = checkJson(json);
			if(checkresult != null){
				errMessage.add(formatRSJsonData("ʧ",checkresult,""));
				returnobj.put("info", "ʧ");
				returnobj.put("errMessage", checkresult);
				returnobj.put("result", errMessage);
				resp.getWriter().write(returnobj.toString());
				NcLog.info(returnobj.toString());
				return;
			}
			JSONArray bodyArray = json.getJSONArray("result");
			for (Object Object : bodyArray) {
				JSONObject bodyObject = JSONObject.parseObject(Object.toString());
				String pk_corp = bodyObject.getString("pk_corp");//ƻ֯
				String vbillcode = bodyObject.getString("vbillcode");//ݺ
				String pk_demandOld = getVbillcode(vbillcode);
				if(!StringUtils.isEmpty(pk_demandOld)) {
					errMessage.add(formatRSJsonData("ʧ","ݺ"+ vbillcode +"Ѵ","").toString());
					returnobj.put("info", "ʧ");
					returnobj.put("errMessage", "ݺ"+ vbillcode +"Ѵ");
					returnobj.put("result", errMessage);
					resp.getWriter().write(returnobj.toString());
					NcLog.info(returnobj.toString());
					return;
				}
				String dbilldate = bodyObject.getString("dbilldate");//
				String billmaker = GetBaseDAOUtil.getUserid(bodyObject.getString("billmaker"));//Ƶ
				if(billmaker.equals("")) {
					errMessage.add(formatRSJsonData("ʧ","Ƶ"+bodyObject.getString("billmaker")+"δ鵽","").toString());
					returnobj.put("info", "ʧ");
					returnobj.put("errMessage", "Ƶ"+bodyObject.getString("billmaker")+"δ鵽");
					returnobj.put("result", errMessage);
					resp.getWriter().write(returnobj.toString());
					NcLog.info(returnobj.toString());
					return;
				}
				String workmanid = GetBaseDAOUtil.getPsndocid(bodyObject.getString("workmanid"));//ҵԱ
				String plandeptid = GetBaseDAOUtil.getDeptdocid(bodyObject.getString("plandeptid"));//ƻ
				String vnote = bodyObject.getString("vnote");//ע
				DemandVO headvo = new DemandVO();
				//ͷֵ
				headvo.setPk_corp(pk_corp);
				headvo.setVbillcode(vbillcode);
				headvo.setDbilldate(new UFDate(dbilldate));
				headvo.setBillmaker(billmaker);
				headvo.setWorkmanid(workmanid);
				headvo.setPlandeptid(plandeptid);
				headvo.setVnote(vnote);
				headvo.setBillstatus(IBillStatus.FREE);
				String pk_demand = dao.insertVO(headvo);
				//帳ֵ
				if(bodyObject.getJSONArray("po")!=null) {
					JSONArray inArray = bodyObject.getJSONArray("po");
					for(int i = 0;i < inArray.size();i++) {
						Object inobj = inArray.get(i);
						JSONObject injsobj = JSONObject.parseObject(inobj.toString());
						String prjcode = injsobj.getString("prjcode");//Ŀ
						String prjname = GetBaseDAOUtil.getprojectname(prjcode);//Ŀ
						String prjtypecode = GetBaseDAOUtil.getprjtypecode(prjcode);//Ŀ
						String prjtypename = GetBaseDAOUtil.getprjtypename(prjcode);//Ŀ
						String vbatchcode = injsobj.getString("vbatchcode");//
						String cmaterialcode = injsobj.getString("cmaterialcode");//
						String cmaterialname = GetBaseDAOUtil.getinvname(cmaterialcode);//
						String spec = GetBaseDAOUtil.getinvspec(cmaterialcode);//
						String model = GetBaseDAOUtil.getinvtype(cmaterialcode);//ͺ
						String width = GetBaseDAOUtil.getwidth(cmaterialcode);//
						String height = GetBaseDAOUtil.getheight(cmaterialcode);//߶
						String unitid = GetBaseDAOUtil.getmeasname(cmaterialcode);//λ
						DemandBVO bodyvo = new DemandBVO();
						bodyvo.setPrjcode(prjcode);;
						bodyvo.setPrjname(prjname);
						bodyvo.setPrjtypecode(prjtypecode);
						bodyvo.setPrjtypename(prjtypename);
						bodyvo.setVbatchcode(vbatchcode);
						bodyvo.setCmaterialcode(cmaterialcode);
						bodyvo.setCmaterialname(cmaterialname);
						bodyvo.setSpec(spec);
						bodyvo.setModel(model);
						bodyvo.setWidth(width);
						bodyvo.setHeight(height);
						bodyvo.setUnitid(unitid);
						bodyvo.setPk_demand(pk_demand);
						dao.insertVO(bodyvo);
					}
				}
				result.add(formatRSJsonData("ɹ","",vbillcode));
			}
			returnobj.put("info", "ɹ");
			returnobj.put("errMessage", "");
			returnobj.put("result", result);
			trans.commit();//ύ
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
		} catch (Exception e) {
			try {
				trans.rollback();//
			} catch (Exception e1) {
				e1.printStackTrace();
			} 
			JSONArray errMessage = new JSONArray();
			JSONObject returnobj = new JSONObject();
			errMessage.add(formatRSJsonData("ʧ",
					e.getMessage(),"").toString());
			returnobj.put("info", "ʧ");
			returnobj.put("errMessage", e.getMessage());
			returnobj.put("result", errMessage);
			resp.getWriter().write(returnobj.toString());
			NcLog.info(returnobj.toString());
			return;
		}
	}

	
	// ѯݺ
    public  String getVbillcode(String vbillcode) throws Exception {
        String sql = "select pk_demand from po_demand where vbillcode ='"+vbillcode+"' and isnull(dr,0) = 0";
        String pk_demand = (String) iuap.executeQuery(sql, new ColumnProcessor());
        if (pk_demand == null) {
            return "";
        }
        return pk_demand;
    }
    
	
	
	/*
	 * ǿж
	 */
	private String checkJson(JSONObject json) throws Exception {
		
		StringBuffer mags = new StringBuffer();
		Boolean empty = true;
		String body = "result";//
		
		if (json.getJSONArray(body)==null) {
			empty = false;
			mags.append("봫ӿݣ ");
			return mags.toString();
		}
		
		JSONArray oprepObjectBs = json.getJSONArray("result");
		
		String vbillcode = "vbillcode";//ݺ
		String pk_corp = "pk_corp";//֯
		String billmaker = "billmaker";//Ƶ
		String dbilldate = "dbilldate";//
		
		String po = "po";//
 
		for(int i = 0; i < oprepObjectBs.size(); i++) {
			JSONObject oprepJsonObjectB = oprepObjectBs.getJSONObject(i);
			String[] HeadKey = {vbillcode,pk_corp,billmaker,dbilldate};
			int num = i+1;
			
			mags.append(""+num+"ͷ{");
			for (String as : HeadKey) {

				if (oprepJsonObjectB.getString(as).isEmpty()) {
					empty = false;
					mags.append("'" + as + "' ");
				}
			}
			mags.append("}");
			
			if(oprepJsonObjectB.getJSONArray(po)==null) {
				mags.append(""+num+"岻Ϊ");
			}
		}
		
		if (!empty) {
			return "ֶβΪգ"+mags;
		}
		else {
			return null;
		}
	}

}
